% Constants
classdef ConstantProperties
    
    properties (Constant) % General constants
        MIN_FRAME_WIDH = 4;
        
        MAX_FRAME_WIDTH_LOG2 = 11;
        MAX_FRAME_WIDTH = 2^ConstantProperties.MAX_FRAME_WIDTH_LOG2 - 1;
        
        MIN_FRAME_HEIGHT = 4;
        
        MAX_FRAME_HEIGHT_LOG2 = 11;
        MAX_FRAME_HEIGHT = 2^ConstantProperties.MAX_FRAME_HEIGHT_LOG2 - 1;
        
        MIN_FRAME_RATE = 1;
        
        MAX_FRAME_RATE_LOG2 = 6;
        MAX_FRAME_RATE = 2^ConstantProperties.MAX_FRAME_RATE_LOG2 - 1;
    end
   
    properties (Constant) % MCTF specific constants
        MIN_NO_TEMPORAL_LEVELS = 0;
        
        MAX_NO_TEMPORAL_LEVELS_LOG2 = 3;
        MAX_NO_TEMPORAL_LEVELS = 2^ConstantProperties.MAX_NO_TEMPORAL_LEVELS_LOG2 - 1;
        
        SUPPORTED_FILTER_TYPES = {'haar', '1/3'};
    end
    
    properties (Constant) % ME specific constants
        MIN_LUMA_BLOCKSIZE = 4;
        
        MAX_LUMA_BLOCKSIZE_LOG2 = 7;
        MAX_LUMA_BLOCKSIZE = 2^ConstantProperties.MAX_LUMA_BLOCKSIZE_LOG2 - 1;
        
        MIN_LUMA_SEARCHRANGE = 2;
        
        MAX_LUMA_SEARCHRANGE_LOG2 = 8;
        MAX_LUMA_SEARCHRANGE = 2^ConstantProperties.MAX_LUMA_SEARCHRANGE_LOG2 - 1;
        
        MAX_NO_HUFFMAN_SYMBOLS_LOG2 = ConstantProperties.MAX_LUMA_SEARCHRANGE_LOG2 + 1;
        
        SUPPORTED_SEARCH_TYPES = {'full', 'diamond'};
    end
    
    properties (Constant) % JPEG 2000 specific constants
        NO_JP2K_SPATIAL_LEVELS_LP_LUMA = 7;
        NO_JP2K_SPATIAL_LEVELS_LP_CHROMA = 6;
        
        NO_JP2K_SPATIAL_LEVELS_HP_LUMA = 5;
        NO_JP2K_SPATIAL_LEVELS_HP_CHROMA = 4;
    end
    
end