% DucksTakeOff enc/dec script
clear all

% ******** Encoder Parameters ***********
fileName = 'C:\zzz_m\test_environment\original_sequences\DucksTakeOff_720p25.yuv';    % Name of YUV4:2:0 file to encode
firstFrame = 0;                 % First frame to encode (0-indexed)
lastFrame = 249;                  % Last frame to encode (0-indexed)
frameWidth = 1280;                    % Frame width
frameHeight = 720;                   % Frame height
frameRate = 25;               % Frame rate
lumaBlockSize = 40;            % Block size for Motion Estimation (Luma, halved for chroma components)
lumaSearchRange = 64;          % Search range for Motion Estimation (Luma, halved for chroma components)
searchType = 'diamond';         % Motion Estimation search type
filterType = '1/3';            % Filter type for MCTF (Haar or 1/3 filter)
numOfTemporalLevels = 3;        % Number of temporal levels for MCTF
                                % decomposition
mvEntropyCoder = 1;             % 0: Canonical Huffman 1: Arithmetic coding

lumaBudgetPercent = 0.85;
CbBudgetPercent = 0.12;
lpPercent = 0.25;
% *******************************

compareToFile = 'C:\zzz_m\test_environment\original_sequences\DucksTakeOff_720p25.yuv';    % Original yuv for PSNR calculation (optional)







% % 5000 kbps ===============================================================
% targetRate = 5000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_5000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_5000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_5000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_5000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================







% 6000 kbps ===============================================================
targetRate = 6000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_6000kbps';        % Name of output folder
logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_6000kbps.txt';

enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
               frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
               numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
           
encode(enc);
clear enc

% Decoder parameters
inputFolder = outputFolder;             % Folder containing encoded stream files
outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_6000kbps';               % Folder to put reconstructed files
outputFileName = 'rec_DucksTakeOff_6000.yuv';         % Output yuv file

d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);

decode(d);
clear d
%==========================================================================










% % 7115 kbps ===============================================================
% targetRate = 7115;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_7115kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_7115kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_7115kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_7115.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 

% % 7426 kbps ===============================================================
% targetRate = 7426;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_7426kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_7426kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_7426kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_7426.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% % 8163 kbps ===============================================================
% targetRate = 8163;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_8163kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_8163kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_8163kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_8163.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% % 8855 kbps ===============================================================
% targetRate = 8855;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_8855kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_8855kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_8855kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_8855.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% % 9760 kbps ===============================================================
% targetRate = 9760;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_9760kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_9760kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_9760kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_9760.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% 
% % 10835 kbps ===============================================================
% targetRate = 10835;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_10835kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_10835kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_10835kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_10835.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% 
% % 12206 kbps ===============================================================
% targetRate = 12206;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_12206kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_12206kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_12206kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_12206.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================







% % 15000 kbps ===============================================================
% targetRate = 15000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_15000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_15000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_15000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_15000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================








% % 17000 kbps ===============================================================
% targetRate = 17000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_17000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_17000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_17000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_17000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================








% % 18000 kbps ===============================================================
% targetRate = 18000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_18000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_18000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_18000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_18000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================









% % 19000 kbps ===============================================================
% targetRate = 19000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_19000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_19000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_19000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_19000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================











% % 24000 kbps ===============================================================
% targetRate = 24000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\DucksTakeOff_24000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_DucksTakeOff_24000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\DucksTakeOff_24000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_DucksTakeOff_24000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================