% Encoder script

% ******** Parameters ***********
fileName = 'C:\ducks.yuv'; % Name of YUV4:2:0 file to encode
firstFrame = 0;            % First frame to encode (0-indexed)
lastFrame = 249;           % Last frame to encode (0-indexed)
frameWidth = 1280;         % Frame width
frameHeight = 720;         % Frame height
frameRate = 25;            % Frame rate
lumaBlockSize = 40;        % Block size for Motion Estimation (Luma, halved for chroma components)
lumaSearchRange = 64;      % Search range for Motion Estimation (Luma, halved for chroma components)
searchType = 'diamond';    % Motion Estimation search type
filterType = '1/3';        % Filter type for MCTF (Haar or 1/3 filter)
numOfTemporalLevels = 3;   % Number of temporal levels for MCTF decomposition
targetRate = 10000;        % Target output bitrate [kbps] (0 = lossless JP2k coding)
mvEntropyCoder = 1;        % 0: Canonical Huffman 1: Arithmetic coding
outputFolder = 'output';   % Name of output folder
lumaBudgetPercent = 0.85;  % Amount of byte budget given to Luma components
CbBudgetPercent = 0.12;	   % Amount of byte budget given to Cb components
lpPercent = 0.25;		   % Amount of byte budget given to LP subbands
logfile = 'log.txt';	   % Name of encoder log file (optional).
% *******************************

enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
               frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
               numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
           
encode(enc);

delete(enc);