% IntoTree enc/dec script
clear all

% ******** Encoder Parameters ***********
fileName = 'C:\zzz_m\test_environment\original_sequences\IntoTree_720p25.yuv';    % Name of YUV4:2:0 file to encode
firstFrame = 0;                 % First frame to encode (0-indexed)
lastFrame = 249;                  % Last frame to encode (0-indexed)
frameWidth = 1280;                    % Frame width
frameHeight = 720;                   % Frame height
frameRate = 25;               % Frame rate
lumaBlockSize = 40;            % Block size for Motion Estimation (Luma, halved for chroma components)
lumaSearchRange = 64;          % Search range for Motion Estimation (Luma, halved for chroma components)
searchType = 'diamond';         % Motion Estimation search type
filterType = '1/3';            % Filter type for MCTF (Haar or 1/3 filter)
numOfTemporalLevels = 3;        % Number of temporal levels for MCTF
                                % decomposition
mvEntropyCoder = 1;             % 0: Canonical Huffman 1: Arithmetic coding

lumaBudgetPercent = 0.865;
CbBudgetPercent = 0.09;
lpPercent = 0.25;
% *******************************

compareToFile = 'C:\zzz_m\test_environment\original_sequences\IntoTree_720p25.yuv';    % Original yuv for PSNR calculation (optional)





% % 6996 kbps ===============================================================
% targetRate = 6996;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_6996kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_6996kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_6996kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_6996.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================






% % 8147 kbps ===============================================================
% targetRate = 8147;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_8147kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_8147kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_8147kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_8147.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% % 8870 kbps ===============================================================
% targetRate = 8870;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_8870kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_8870kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_8870kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_8870.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% % 9821 kbps ===============================================================
% targetRate = 9821;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_9821kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_9821kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_9821kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_9821.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% 
% 
% 
% % 10749 kbps ===============================================================
% targetRate = 10749;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_10749kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_10749kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_10749kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_10749.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% 
% % 11830 kbps ===============================================================
% targetRate = 11830;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_11830kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_11830kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_11830kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_11830.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================








% % 16000 kbps ===============================================================
% targetRate = 16000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_16000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_16000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_16000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_16000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================











% % 20000 kbps ===============================================================
% targetRate = 20000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_20000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_20000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_20000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_20000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================











% 25000 kbps ===============================================================
targetRate = 25000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_25000kbps';        % Name of output folder
logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_25000kbps.txt';

enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
               frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
               numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
           
encode(enc);
clear enc

% Decoder parameters
inputFolder = outputFolder;             % Folder containing encoded stream files
outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_25000kbps';               % Folder to put reconstructed files
outputFileName = 'rec_intoTree_25000.yuv';         % Output yuv file

d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);

decode(d);
clear d
%==========================================================================










% % 30000 kbps ===============================================================
% targetRate = 30000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\intoTree_30000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_intoTree_30000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\intoTree_30000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_intoTree_30000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
