% OldTownCross enc/dec script
clear all

% ******** Encoder Parameters ***********
fileName = 'C:\zzz_m\test_environment\original_sequences\OldTownCross_720p25.yuv';    % Name of YUV4:2:0 file to encode
firstFrame = 0;                 % First frame to encode (0-indexed)
lastFrame = 249;                  % Last frame to encode (0-indexed)
frameWidth = 1280;                    % Frame width
frameHeight = 720;                   % Frame height
frameRate = 25;               % Frame rate
lumaBlockSize = 40;            % Block size for Motion Estimation (Luma, halved for chroma components)
lumaSearchRange = 64;          % Search range for Motion Estimation (Luma, halved for chroma components)
searchType = 'diamond';         % Motion Estimation search type
filterType = '1/3';            % Filter type for MCTF (Haar or 1/3 filter)
numOfTemporalLevels = 3;        % Number of temporal levels for MCTF
                                % decomposition
mvEntropyCoder = 1;             % 0: Canonical Huffman 1: Arithmetic coding

lumaBudgetPercent = 0.9;
CbBudgetPercent = 0.05;
lpPercent = 0.25;
% *******************************

compareToFile = 'C:\zzz_m\test_environment\original_sequences\OldTownCross_720p25.yuv';    % Original yuv for PSNR calculation (optional)


% % 7181 kbps ===============================================================
% targetRate = 7181;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_7181kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_7181kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_7181kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_7181.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 






% 7700 kbps ===============================================================
targetRate = 7700;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_7700kbps';        % Name of output folder
logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_7700kbps.txt';

enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
               frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
               numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
           
encode(enc);
clear enc

% Decoder parameters
inputFolder = outputFolder;             % Folder containing encoded stream files
outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_7700kbps';               % Folder to put reconstructed files
outputFileName = 'rec_oldTownCross_7700.yuv';         % Output yuv file

d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);

decode(d);
clear d
%==========================================================================











% 
% 
% % 8206 kbps ===============================================================
% targetRate = 8206;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_8206kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_8206kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_8206kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_8206.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% % 9167 kbps ===============================================================
% targetRate = 9167;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_9167kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_9167kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_9167kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_9167.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% % 9941 kbps ===============================================================
% targetRate = 9941;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_9941kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_9941kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_9941kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_9941.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% % 11136 kbps ===============================================================
% targetRate = 11136;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_11136kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_11136kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_11136kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_11136.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================






% % 11998 kbps ===============================================================
% targetRate = 11998;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_11998kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_11998kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_11998kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_11998.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================













% % 14000 kbps ===============================================================
% targetRate = 14000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_14000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_14000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_14000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_14000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================
% 
% 
% 
% 
% 
% 
% 
% 
% 
% % 17000 kbps ===============================================================
% targetRate = 17000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_17000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_17000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_17000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_17000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================










% % 19000 kbps ===============================================================
% targetRate = 19000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_19000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_19000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_19000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_19000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================








% % 20000 kbps ===============================================================
% targetRate = 20000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_20000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_20000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_20000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_20000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================













% % 25000 kbps ===============================================================
% targetRate = 25000;                 % Target output bitrate [kbps] (0 = lossless JP2k coding)
% outputFolder = 'C:\zzz_m\test_environment\proposed\str\oldTownCross_25000kbps';        % Name of output folder
% logfile = 'C:\zzz_m\test_environment\proposed\log\log_oldTownCross_25000kbps.txt';
% 
% enc = Encoder(fileName, firstFrame, lastFrame, frameWidth, frameHeight,...
%                frameRate, lumaBlockSize, lumaSearchRange, searchType, filterType,...
%                numOfTemporalLevels, targetRate, mvEntropyCoder, outputFolder, lumaBudgetPercent, CbBudgetPercent, lpPercent, logfile );
%            
% encode(enc);
% clear enc
% 
% % Decoder parameters
% inputFolder = outputFolder;             % Folder containing encoded stream files
% outputFolder = 'C:\zzz_m\test_environment\proposed\rec\oldTownCross_25000kbps';               % Folder to put reconstructed files
% outputFileName = 'rec_oldTownCross_25000.yuv';         % Output yuv file
% 
% d = Decoder(inputFolder, outputFolder, outputFileName, logfile, compareToFile);
% 
% decode(d);
% clear d
% %==========================================================================