% Setup script

% Make sure jasPer is installed
[status, result] = system('jasper --version');
if (status == 0)
    fprintf('Installed JasPer version:\n%s', result);
else
    error('JasPer is not installed. Please install, add to system path and run setup again');
end

% Add utils folder to path
oldFolder = cd('utils');
Arith07_name = 'Arith07.m';
utils_path = which(Arith07_name); 
addpath( utils_path(1:end-length(Arith07_name)) );
cd(oldFolder);

% Add codec folder to path
cd('codec');
Encoder_name = 'Encoder.m';
codec_path = which(Encoder_name); 
addpath( codec_path(1:end-length(Encoder_name)) );
cd(oldFolder);

% Run metrix_mux setup script
oldFolder = cd('utils/metrix_mux');
configure_metrix_mux

%Change directory back to previous
cd(oldFolder);

fprintf('\n\nSETUP FINISHED\n\n');

clear all